//+------------------------------------------------------------------+
//|                                                   DailyPivot.mq4 |
//|                                                Copyright fxinvjp |
//|                                           http://www.fxinvjp.com |
//+------------------------------------------------------------------+
#property copyright "Copyright fxinvjp"
#property link      "http://www.fxinvjp.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Black
#property indicator_color4 DarkBlue
#property indicator_color5 DarkBlue
//---- input parameters

//---- buffers
double Support2[];
double Support1[];
double Pivot[];
double Resistance1[];
double Resistance2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Support2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Support1);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Pivot);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,Resistance1);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Resistance2);
   string shortname = "Daily Pivot";
   IndicatorShortName(shortname);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();

   if(Bars<=0)
   {
      Print("Not enough Bars");
      return(0);
   }
   

   if (counted_bars<0)
   return(-1);
   //last bar will be recounted
   if(counted_bars>0)
   counted_bars--;
   
   int pos = Bars-counted_bars;
   
   while(pos>0)
   {
      Pivot[pos]=(iHigh(NULL,PERIOD_D1,1)+iLow(NULL,PERIOD_D1,1)+iClose(NULL,PERIOD_D1,1))/3.0;
      Support1[pos]=2*Pivot[pos]-iHigh(NULL,PERIOD_D1,1);
      Support2[pos]=Pivot[pos]-(iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1));
      Resistance1[pos]=2*Pivot[pos]-iLow(NULL,PERIOD_D1,1);
      Resistance2[pos]=Pivot[pos]+(iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1));
      
      pos--;
      
    }

   return(0);
  }
//+------------------------------------------------------------------+