//+------------------------------------------------------------------+
//|                                                   HistVolume.mq4 |
//|                                                Copyright fxinvjp |
//|                                           http://www.fxinvjp.com |
//+------------------------------------------------------------------+
#property copyright "Copyright fxinvjp"
#property link      "http://www.fxinvjp.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_level1 0.0
#property indicator_width1 2

//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   string shortname = "Hist Vol";
   IndicatorShortName(shortname);
   
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   if(Bars<=0)
   {
      Print("Not enough Bar");
      return(0);
   }
   
    int timeFrame = Period();
   
   int VolumeHistPeriod = 1440/timeFrame;
   
   if(Bars<VolumeHistPeriod)
   {  
      Alert("Not enough Bar");
      return(false);
   }
   
   
   if (counted_bars>0)
   counted_bars--;
   
   int pos = Bars-counted_bars;
   
   while(pos>0)
   {
     
      ExtMapBuffer1[pos]=iVolume(NULL,Period(),pos)-Volumemoyen(pos,VolumeHistPeriod);
      
      pos--;  
   }
   
   return(0);
  }
//+------------------------------------------------------------------+

double Volumemoyen(int shift,int VolumeHistPeriod)
{
   double Vm=0;
   for(int i=1;i<=VolumeHistPeriod;i++)
   {  
      Vm+=iVolume(NULL,Period(),shift+i);
   }
   
   return(Vm/VolumeHistPeriod);
 }